/*
 * OpenDEM www.opendem.info
 * the code is under the unlicense license, do what you like
 */

package info.opendem.opendemtracker;

import info.opendem.opendemtracker.Pressure;
import info.opendem.opendemtracker.Pressure.LocalBinder;

import java.util.zip.GZIPInputStream;
import java.util.zip.GZIPOutputStream;
import java.util.zip.ZipEntry;
import java.util.zip.ZipFile;
import java.util.zip.ZipOutputStream;
import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.UUID;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.StatusLine;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.ByteArrayEntity;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.util.EntityUtils;

import android.annotation.SuppressLint;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.content.BroadcastReceiver;
import android.content.ComponentName;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.ServiceConnection;
import android.content.res.Resources;
import android.location.Location;
import android.media.MediaScannerConnection;
import android.net.ParseException;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.os.Environment;
import android.os.IBinder;
import android.os.StrictMode;
import android.support.v4.content.LocalBroadcastManager;
import android.text.Editable;
import android.text.InputType;
import android.util.Log;
import android.view.KeyEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;
import android.graphics.Color;
import android.hardware.Sensor;
import android.hardware.SensorManager;
import android.view.View.OnKeyListener;
import info.opendem.opendemtracker.R;
import org.apache.commons.lang3.StringUtils;

@SuppressLint("Wakelock")

public class OpenDemTracker extends Activity implements OnClickListener, OnKeyListener{

    private TextView viewLongitude;
    private TextView viewLatitude;
    private TextView viewHeight;
    private TextView viewHeightInputType;
    private TextView progressBar;    
    private TextView progressBarSave;
	boolean serviceStartet = false;	
// Binder for communication with service class
    boolean mBounded = false;
    Pressure mPressure;
    private SimpleDateFormat gpxTimeFormat;
    private Button startButton;
    private Button stopButton;
    private Button saveButton;
    private Button mapButton;
    private Button exitButton;
    private Button helpButton;
    private boolean collectData;
    private boolean isHeightSet = false;
    private boolean useHeightService = false;
    private Integer idCounter = 0;
    private boolean useDemService = false; 
    private List<Location> positions;
    // 	logging
    private static final String TAG = "MyActivity";
    // sensor 
	private Sensor pressure        = null;
	private SensorManager sensorManager = null; 
  // issue
	private List<String> pressureList; 
	private Float initialPressureDevice = null;
	private Double initialPressure = null;
	double initialPressureAPI = -1000;
	private String pressureAPI = null;
	// test coordinates
	private Double xcoord = 50.958101355;
	private Double ycoord = 7.011655343;
	private Double heightEdit = null;
	// perhaps for later use
	private Integer heightStationEdit = null;
	//textbox
	private EditText eingabefeld; 
	// textbox station id 
	private EditText stationId;
	//initial heigt
	private Float initialHeight = null; 
	private Float actualHeight = null;
	private Float initialPreasure = null;
	private Float preasureDiff = null;
	double lastMessureApi = -1000.0;
	double actualMessureApi = -1000.0;
	double pressureDeltaApi = 0;
	double corHeightApi = -1000.0;
	UUID uuidServer; 
	// pressure service
	Intent intentP;
	//dialog
	private final int ALERT_DIALOG    = 0;
	private Dialog dialogSave;
	
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        LocalBroadcastManager.getInstance(this).registerReceiver(
                mMessageReceiver, new IntentFilter("status"));
        
        setContentView(R.layout.main);
        
    	eingabefeld = (EditText) findViewById(R.id.editText);
		eingabefeld.setOnKeyListener(this);	

// perhaps later usefull		
//		stationId = (EditText) findViewById(R.id.editStationText);
//		stationId.setOnKeyListener(this);
       
        startButton = (Button) this.findViewById(R.id.button1);
        startButton.setOnClickListener(this);
        
        // Save-Button
        saveButton = (Button) this.findViewById(R.id.button3);
        saveButton.setOnClickListener(this);
        saveButton.setEnabled(false);
        
     // Exit-Button
        exitButton = (Button) this.findViewById(R.id.button4);
        exitButton.setOnClickListener(this);
        
        // Map-Button
        mapButton = (Button) this.findViewById(R.id.button5);
        mapButton.setOnClickListener(this);
        
        
        // help-Button
        helpButton = (Button) this.findViewById(R.id.button2);
        helpButton.setOnClickListener(this);
        
       
        positions   = new ArrayList<Location>();
        viewLatitude  = (TextView) this.findViewById(R.id.textViewLatitude);
        viewLongitude  = (TextView) this.findViewById(R.id.textViewLongitude);
       viewHeight   = (TextView) this.findViewById(R.id.textViewHeight);
        viewHeightInputType  = (TextView) this.findViewById(R.id.textViewHeightInputType);
        gpxTimeFormat = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss'Z'");
     
        // progressBar
        progressBar = (TextView) this.findViewById(R.id.progressBarText1);

       
        //images
       ImageView img = (ImageView)findViewById(R.id.dwd_logo);
       img.setOnClickListener(new View.OnClickListener(){
           public void onClick(View v){
               Intent intent = new Intent();
               intent.setAction(Intent.ACTION_VIEW);
               intent.addCategory(Intent.CATEGORY_BROWSABLE);
               intent.setData(Uri.parse("http://www.dwd.de"));
               startActivity(intent);
           }
       });
       
       ImageView img2 = (ImageView)findViewById(R.id.mapzen_logo);
       img2.setOnClickListener(new View.OnClickListener(){
           public void onClick(View v){
               Intent intent = new Intent();
               intent.setAction(Intent.ACTION_VIEW);
               intent.addCategory(Intent.CATEGORY_BROWSABLE);
               intent.setData(Uri.parse("https://mapzen.com"));
               startActivity(intent);
           }
       });
    }
    
    // for binding with service class
    ServiceConnection mConnection = new ServiceConnection() {

        public void onServiceDisconnected(ComponentName name) {
        //	Log.d("statusOpenDEM", "service disconnected");
        	mBounded = false;
            mPressure = null;
        }

        public void onServiceConnected(ComponentName name, IBinder service) {
        	// We've bound to LocalService, cast the IBinder and get LocalService instance
            LocalBinder mLocalBinder = (LocalBinder)service;
            mPressure = mLocalBinder.getService();
            mBounded = true;
        }
    };
    
    //Click for start/save
    	@SuppressWarnings("deprecation")
		public void onClick(View v) {
		if(v == startButton) {
			uuidServer = null;
		//	Log.d("gps", "height: " +viewHeight.getText());
			if ((viewHeight.getText().toString().trim().length() == 0) & (useDemService == false)){
				showDialog(ALERT_DIALOG);
			} else {
			intentP = new Intent(this, Pressure.class);
			if (useDemService == true){
				initialPressureDevice = (float) -9999;
			} else {
				initialPressureDevice = Float.parseFloat(viewHeight.getText().toString());
			}
			intentP.putExtra("data", initialPressureDevice);
		//	Log.d("pressureservice", "start button");
			 progressBar.setText("Please wait while fixing the initial GPS position!");
			bindService(intentP, mConnection, BIND_AUTO_CREATE);
	        startService(intentP);
	        serviceStartet = true;	
	  		startButton.setEnabled(false);
			saveButton.setEnabled(true);
        //	Log.d("pressureservice", "mPressure" +mPressure);
            }}
	
		else if(v == saveButton){
			  mPressure.onStop();
			startButton.setEnabled(true);
			saveButton.setEnabled(false);
			progressBar.setText("save button clicked");
			
			
		    saveData();
		}
		else if(v == exitButton){ 
		   finish();
			  
		}
		else if(v == helpButton){ 
			HelpDialog helpDialog = new HelpDialog(OpenDemTracker.this);
			helpDialog.setTitle("Help");
			helpDialog.show(); 
			
		}
		else if(v == mapButton){ 
			Uri uri = Uri.parse("https://ssl-id1.de/www.opendem.info/ol3/mobile.html"); 
			Intent intent = new Intent(Intent.ACTION_VIEW, uri);
			startActivity(intent); 
			
		}
		
	}

 // input field

	    public boolean onKey(View v, int keyCode, KeyEvent event) {
	    	
	        if ((event.getAction() == KeyEvent.ACTION_DOWN) &&
                (keyCode == KeyEvent.KEYCODE_ENTER)) {
	        //	Toast.makeText(v.getContext(), eingabefeld.getText(), Toast.LENGTH_SHORT).show();
	        	viewHeight.setText(eingabefeld.getText());
	        	eingabefeld.setSelected(false);
	        	return true;
	        }        
	        return false;
	    };
		

		@Override
		public void onDestroy() {
		//	Toast.makeText(getApplicationContext(), "App will be destroyed", Toast.LENGTH_LONG).show();
			
			if (serviceStartet == true){
			stopService(intentP);
			 unbindService(mConnection);
			}
		//	  Log.d("statusOpenDEM", "app destroyed");
			  super.onDestroy();
		}

         // Dialog for Saving the data 
    private void saveData() {
    	
    	//check if anything is logged
    //	Log.d("statusOpenDEM", "listsize "+ mPressure.dataList.size());
    	  if (mPressure.dataList.size() < 1){
    		  savedAndFinish("No data recorded - App will finish now");    		      		  
    	  } else {
    	
    	try {
     	//  final Dialog dialog = new Dialog(this);
    		  dialogSave = new Dialog(this);
     	  
    	  dialogSave.setOwnerActivity(this);
    	  dialogSave.setContentView(R.layout.save);
    	  // Dialogelements initialise
    	  Resources res = getResources();
    	  
    	  dialogSave.setTitle(res.getText(R.string.saveDialogTitel));
    	  final EditText filename = (EditText) dialogSave.findViewById(R.id.editTextFile); 
    	  filename.setText("filename");
    	  
    	  final TextView progressBarSave = (TextView) dialogSave.findViewById(R.id.progressBarText2);
    	  progressBarSave.setText(" I agree that the stored data on the server will be published under a free license. \n No personal data is stored! \n Upload and processing on device could take several minutes!");
    	  
    
    	  // save on device
    	  Button save = (Button) dialogSave.findViewById(R.id.saveLocal);
    	  save.setOnClickListener(new OnClickListener() {
             public void onClick(View v) {
            	Editable ed = filename.getText();
            	
            	try {
            	progressBarSave.setText("Please wait while saving on Device");
                  writePositions(ed.toString(), "only");
     			  positions.clear();
            	}
            	catch(Exception ex) {
            //		Log.d("statusOpenDEM", ex.getMessage());
            	}
            	progressBarSave.setText("status");
            	dialogSave.dismiss();
             }
          });
    	  
    	  // save on server
    	  Button saveServer = (Button) dialogSave.findViewById(R.id.saveServer);
    	  if (mPressure.internet == false){
    		
    		  saveServer.setVisibility(View.GONE);
    	  } else {
    	  saveServer.setOnClickListener(new OnClickListener() {
             public void onClick(View v) {
            	Editable ed = filename.getText();
            	
            	try {
            		progressBarSave.setText("Please wait while saving on Server");
            		saveToServer(ed.toString(), "only");
       		  positions.clear();
            	}
            	catch(Exception ex) {
            //		Log.d("statusOpenDEM", ex.getMessage());
            	}
            	progressBarSave.setText("status");
            	dialogSave.dismiss();
             }

			
          });
    	  }
    	  
    	  // save on both
    	  Button saveBoth = (Button) dialogSave.findViewById(R.id.saveBoth);
    	  if (mPressure.internet == false){
      		
    		  saveBoth.setVisibility(View.GONE);
    	  } else {
    	  saveBoth.setOnClickListener(new OnClickListener() {
             public void onClick(View v) {
            	Editable ed = filename.getText();
            	
            	try {
            		progressBarSave.setText("Please wait while saving on Server and Device");
            		saveToServer(ed.toString(), "both");
                  writePositions(ed.toString(), "both");
     			  positions.clear();
     			 dialogSave.dismiss();
     			 savedAndFinish("Saved on Server and Device - App will finish now");
            	}
            	catch(Exception ex) {
            //		Log.d("statusOpenDEM", ex.getMessage());
            	}
            	
            	dialogSave.dismiss();
             }

			
          });
    	  }
    	  
    	  dialogSave.show();
    	} 
    	catch(Exception ex) {
    	//	Log.d("statusOpenDEM", ex.getMessage());
    	}
    }
    }
    
    /**
     * saves the data on the OpenDEMServer
     * 
     */
    private void saveToServer (String filename, String modus) throws Exception {
    	
    	Date datex = new Date();
    //	Log.d("statusOpenDEM", "save to server Start vo berechnung" + datex.toString());
    	 //Log.d("statusOpenDEM", "initialPressure "+ initialPressure);
    	// process start
     	
    	String contentData;
     	
    	//	String contentData;
    	 //metadata
    	 Date date = new Date();
    	 uuidServer  = UUID.randomUUID(); 
    	 
    	 String dateString =  date.toString();
    	 dateString = dateString.replace("MEZ", "CET");
    	 dateString = dateString.replace("MESZ", "CEST");
    	   contentData = dateString  +"," + mPressure.sensorName+","+Build.MODEL+","+Build.PRODUCT+","+ mPressure.wApiName+","+mPressure.wApiLat+","+mPressure.wApiLon+","+ mPressure.wApiDistance+ ","+ viewHeight.getText()+","+mPressure.heightInputType+","+uuidServer+",dwd@";
    	//   Log.d("statusOpenDEM", "metadata "+ contentData);
     	     contentData += StringUtils.join(mPressure.dataList,"@");
    	     byte[] compressed = compress(contentData);
    	     Date datey = new Date();
    //	Log.d("statusOpenDEM", "save to server vor post "+ datey.toString());
        
  		StrictMode.ThreadPolicy policy = new StrictMode.ThreadPolicy.Builder().permitAll().build();
  		StrictMode.setThreadPolicy(policy); 
        HttpClient client = new DefaultHttpClient();
        HttpPost httpPost = new HttpPost("http://www.opendem.info:8080/OpenDEMTracker/SaveTrack");
    	
        List<NameValuePair> urlParameters = new ArrayList<NameValuePair>();
    	//urlParameters.add(new BasicNameValuePair("compressed", compressed));
   /* 	urlParameters.add(new BasicNameValuePair("test", "test"));
    	urlParameters.add(new BasicNameValuePair("test", "metadaten"));
    	httpPost.setEntity(new UrlEncodedFormEntity(urlParameters)); */

    
        ByteArrayEntity entityByte = new ByteArrayEntity(compressed);
        entityByte.setChunked(true);
        entityByte.setContentType("application/octet-stream");
        httpPost.setEntity(entityByte);
    	
    	
    	try {
          HttpResponse response = client.execute(httpPost);
          StatusLine statusLine = response.getStatusLine();
          int statusCode = statusLine.getStatusCode();
          if (statusCode == 200) {
        	  
        	  Date datez = new Date();
        //  	Log.d("statusOpenDEM", "response  " + EntityUtils.toString(response.getEntity()) + " timestamp "+ datez.toString());
 
          	progressBar.setText("data saved on server");
          	
          	if (modus == "only"){
          		dialogSave.dismiss();
          		savedAndFinish("Saved on Server - App will finish now");
          		}
          	
          } else {
        	  Date dateF = new Date();
        	//	Log.d("statusOpenDEM", "response failes  "+statusCode+ " timestamp "+ dateF.toString());
        		progressBar.setText("data could not be saved on server");
        		dialogSave.dismiss();
        		savedAndFinish("Soemthing went wrong - App will finish now");
          }
        } catch (ClientProtocolException e) {
          e.printStackTrace();
     //     Log.d("statusOpenDEM", "response failes  proto exeption");
          progressBar.setText("data could not be saved on server");
          dialogSave.dismiss();
          savedAndFinish("Soemthing went wrong - App will finish now");
        }catch (IOException e) {
            e.printStackTrace();
      //      Log.d("statusOpenDEM", "response failes  io exeption");
            progressBar.setText("data could not be saved on server");
            dialogSave.dismiss();
            savedAndFinish("Soemthing went wrong - App will finish now");
        }
	}
    
    
    /**
     * Saves the data on a SD-Card 
     * @throws Exception
     */
	private void writePositions(String filename, String modus) throws Exception {
		
   //     Log.d("statusOpenDEM", "start save on device");
		
		File sdKarte             = Environment.getExternalStorageDirectory();
	     boolean sdCardAvailable = (sdKarte.exists() && sdKarte.canWrite());
         File file;
         File fileMeta;
         File filePressure;

         if(sdCardAvailable) {
        	 
        	file = new File(sdKarte.getAbsolutePath() + File.separator + filename+".csv");
        	fileMeta = new File(sdKarte.getAbsolutePath() + File.separator + filename+ "_meta.csv");
        	filePressure = new File(sdKarte.getAbsolutePath() + File.separator + filename+ "_pressure.csv");
         }
         else {
        	 file = new File(getFilesDir() + File.separator + filename);
        	 fileMeta = new File(getFilesDir() + File.separator + filename + ".meta"); 
        	 filePressure = new File(getFilesDir() + File.separator + filename + ".pressure");
        //	 Log.d(TAG, "file= "+file);
         }
 try { 
	 
         BufferedWriter writer = new BufferedWriter(new FileWriter(file));
         // file header
         writer.write("id,time,lon,lat,gpsAccuracy,gpsHeight,pressureWApi,pressureCor,pressureFilter,pressureRaw,height,heightCor");
         writer.newLine();
         
    	 double pressureDevD;
    	 double pressureApiD;
    	 double initialPressureV;
    	 double initialHeightV;
    	  double pressureDeltaDev;
    	 double height;
    	 // close to a formula till 6000 meters
             double heightBaroStep;
             double corHeight;
             double heightRaw;
         
         for(String ausgabe : mPressure.dataList) {
        	 idCounter = idCounter + 1;
        	 String[] parts = ausgabe.split(",");
        	 String  pressureDev = parts[6];
        	 String  pressureApi = parts[5];
        	 	
        //	 Log.d("gps", "pressureApi "+pressureApi);
        	 
        	 if (mPressure.internet == false){
        		 
        		 
        	//	 Log.d("gps", "pressureApi null "+pressureApi);
          	   writer.write(idCounter+"," + String.valueOf(ausgabe));
               writer.newLine();
        		 
        	 } else {
        	 
        	 pressureDevD = Double.parseDouble(pressureDev);
        	  pressureApiD = Double.parseDouble(pressureApi);
        	 initialPressureV = (double)initialPressure;
        	 initialHeightV = mPressure.wApiHeight;
        	 pressureDeltaDev = initialPressureV - pressureDevD;
        	 height = initialHeightV - (pressureDeltaDev * 8);
        	 // close to a formula till 6000 meters
                 heightBaroStep = 8 + (height/1000);
                 corHeight = initialHeightV + (pressureDeltaDev * heightBaroStep);
                 heightRaw = corHeight;
                 // correction with the weather api
                 if (initialPressureAPI == -1000){
                	 initialPressureAPI = pressureApiD;
                	  lastMessureApi = initialPressureAPI;
                 }
            	 actualMessureApi = pressureApiD;
          	   if (lastMessureApi != actualMessureApi){
          	//        Log.d("statusOpenDEM", "last " +lastMessureApi +" actual "+ actualMessureApi);
            		   pressureDeltaApi = lastMessureApi - actualMessureApi;  
            		  lastMessureApi = actualMessureApi;
               }
          	   if (corHeightApi == -1000.0){
          		 corHeightApi = corHeight - (pressureDeltaApi * heightBaroStep);
          	   } else {
            	   corHeightApi = corHeight - (pressureDeltaApi * heightBaroStep);
            	   } 
        	   writer.write(idCounter+"," + String.valueOf(ausgabe)+","+ heightRaw +"," + corHeightApi);
               writer.newLine();
     }}   
         progressBar.setText("data saved, unplug the device to see");
         writer.close();
         // You have to unplug and replug the device to see the 
         // latest changes.

MediaScannerConnection.scanFile((Context)(this),
        new String[] { file.toString() },
        null,
        null);
	
} catch (IOException e) {
//	 Log.d("statusOpenDEM", "error while file writing");
	 e.printStackTrace();
}
 
 
 
 
 // metadata
 try { 
     BufferedWriter writerMeta = new BufferedWriter(new FileWriter(fileMeta));
     Date date = new Date();
     
     if (uuidServer == null){ 
     uuidServer  = UUID.randomUUID();}
     
     // fileheader
     writerMeta.write("date,sensor,mobileModel,mobileProduct,weatherApiStation,weatherApiLat,weatherApiLon,weatherApiDistance,enteredHeight,heightInputType,uuid");
     writerMeta.newLine();
     writerMeta.write(date.toString() +"," + mPressure.sensorName+","+Build.MODEL+","+Build.PRODUCT+","+ mPressure.wApiName+","+mPressure.wApiLat+","+mPressure.wApiLon+","+ mPressure.wApiDistance+ ","+ viewHeight.getText()+","+mPressure.heightInputType+","+uuidServer);
  //   Log.d("gps", date.toString()     +"," + mPressure.sensorName+","+Build.MODEL+","+Build.PRODUCT+","+ mPressure.wApiName+","+mPressure.wApiLat+","+mPressure.wApiLon+","+ mPressure.wApiDistance+ ","+ viewHeight.getText()+","+mPressure.heightInputType);
     writerMeta.close();
   
MediaScannerConnection.scanFile((Context)(this),
    new String[] { fileMeta.toString() },
    null,
    null);

} catch (IOException e) {
 // Log.d(TAG, "error while writing file");
 e.printStackTrace();
}
 // pressure values only for the testing 
 try { 
     BufferedWriter writerPressure = new BufferedWriter(new FileWriter(filePressure));
     Date date = new Date();
     // fileheader
     writerPressure.write("date,pressure");
     writerPressure.newLine();
     for(String ausgabeP : mPressure.pressureListAll) {
     writerPressure.write(ausgabeP);
     writerPressure.newLine();
     }
 //    Log.d("gps", date.toString()     +"," + mPressure.sensorName+","+Build.MODEL+","+Build.PRODUCT+","+ mPressure.wApiName+","+mPressure.wApiLat+","+mPressure.wApiLon+","+ mPressure.wApiDistance+ ","+ eingabefeld.getText().toString()+","+mPressure.heightInputType);
     writerPressure.close();
    
MediaScannerConnection.scanFile((Context)(this),
    new String[] { filePressure.toString() },
    null,
    null);

} catch (IOException e) {
 // Log.d(TAG, "error while writing file");
 e.printStackTrace();
}
 
 // Log.d("statusOpenDEM", "end save on device");
 
 if (modus == "only"){
	 dialogSave.dismiss();
	 savedAndFinish("Saved on Device - App will finish now");
		}


//clear textfields not used yet
	viewHeight.setText("");
	eingabefeld.setText("");
     viewLongitude.setText("");
    viewLatitude.setText("");
    viewHeightInputType.setText("");
    // setback variables
    
	}
    
    // Call User to turn on GPS 
     
    private void warningAndFinish(String string) {
    	 AlertDialog.Builder builder = new AlertDialog.Builder(this);
    	 Resources res = getResources();
    	 String text   = string;
    	 builder.setMessage(text); 
    	 builder.setPositiveButton("OK", new DialogInterface.OnClickListener() {
             public void onClick(DialogInterface dialog, int id) {
                 dialog.dismiss();
                 finish(); // end Activity
             }
         });
    	 AlertDialog dialog = builder.create();
    	 dialog.show();
    }
    
    private void savedAndFinish(String string) {
   	 AlertDialog.Builder builder = new AlertDialog.Builder(this);
   	 Resources res = getResources();
   	 String text   = string;
   	 builder.setMessage(text); 
   	 builder.setPositiveButton("OK", new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog, int id) {
                dialog.dismiss();
                // we have to close the save dialog
                
                finish(); // end Activity
            }
        });
   	 AlertDialog dialog = builder.create();
   	 dialog.show();
   }
    
    private BroadcastReceiver mMessageReceiver = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {
        	 
            Bundle extras = intent.getExtras();
            String status = extras.getString("status");
            if (status == "noSensor"){
       //      Log.d("gps", "no sensor available");
          	  warningAndFinish("Sorry, no pressure sensor available on this device");
          }
            if (status == "noGps"){
            //	  Log.d("gps", "turn on gps");
            	  warningAndFinish("No GPS receiver. Please activate!");
            }
            if (status == "logging"){
            	progressBar.setText("Logging data");
           	 try {
   				initialPressure = mPressure.initialPressure;
   				viewHeight.setText(mPressure.wApiHeight.toString());
   				   viewLongitude.setText(mPressure.wApiLon.toString());
   				   viewLatitude.setText(mPressure.wApiLat.toString());
   				   viewHeightInputType.setText(mPressure.heightInputType);
   			} catch (Exception e) {
   				// TODO Auto-generated catch block
   				e.printStackTrace();
   			} 
          	  
          }
        	
        
             }
    };

    // Alert box when no height was entered
    
	private AlertDialog createAlertDialog() {
		AlertDialog.Builder builder = new AlertDialog.Builder(this);
		 final EditText input = new EditText(this);
		    builder.setView(input);
		    input.setInputType(InputType.TYPE_NUMBER_FLAG_DECIMAL |InputType.TYPE_CLASS_NUMBER);
		builder.setTitle("Initial height");
		builder.setMessage("Please set here the height at starting point manually or use a service."); 
		builder.setPositiveButton("Use Service", new DialogInterface.OnClickListener() {
		           public void onClick(DialogInterface dialog, int id) {
		               // set variable for service use
		        	   useDemService = true;
		        	   startButton.performClick();
		        	    dialog.dismiss();
		           }
		       });
		
		builder.setNegativeButton("OK", new DialogInterface.OnClickListener() {
		           public void onClick(DialogInterface dialog, int id) {
		               // check input for number
			       //    Log.d("gps", input.getText().toString());
		        	   if(input.getText().toString().trim().length() == 0){
		        		//   Toast.makeText(getApplicationContext(), "Please try again an enter a number!",Toast.LENGTH_LONG).show();
		        		   dialog.dismiss();   		        		   
		        	   } else {
		        		   
		        		 	viewHeight.setText(input.getText().toString());
		        		 	startButton.performClick();
		        		 	dialog.dismiss();   		   
		        	   }
		           }
		       });
		
		builder.setCancelable(false); 
		AlertDialog dialog = builder.create();
		return dialog; 
	}
	protected Dialog onCreateDialog(int id) {
        Dialog result = null;
    	switch(id) {
		   case ALERT_DIALOG    : result = createAlertDialog();
		                          break; 
		}
		return result; 
	}
	
	public static void zipFile(File inputFile, String zipFilePath) {
        try {
        	
        	
        	 OutputStream os =  new FileOutputStream(zipFilePath);
        			 byte[] bytes = new byte[1024];
        			 GZIPOutputStream zos = new GZIPOutputStream(new BufferedOutputStream(os));
        			 try {
        			     zos.write(bytes);
        			 } finally {
        			     zos.close();
        			 }

        	

            // Wrap a FileOutputStream around a ZipOutputStream
            // to store the zip stream to a file. Note that this is
            // not absolutely necessary
            FileOutputStream fileOutputStream = new FileOutputStream(zipFilePath);
            ZipOutputStream zipOutputStream = new ZipOutputStream(fileOutputStream);

            // a ZipEntry represents a file entry in the zip archive
            // We name the ZipEntry after the original file's name
            ZipEntry zipEntry = new ZipEntry(inputFile.getName());
        //    Log.d("gps", inputFile.getName());
            zipOutputStream.putNextEntry(zipEntry);

            FileInputStream fileInputStream = new FileInputStream(inputFile);
            byte[] buf = new byte[1024];
            int bytesRead;

            // Read the input file by chucks of 1024 bytes
            // and write the read bytes to the zip stream
            while ((bytesRead = fileInputStream.read(buf)) > 0) {
                zipOutputStream.write(buf, 0, bytesRead);
            }

            // close ZipEntry to store the stream to the file
            zipOutputStream.closeEntry();
            zipOutputStream.close();
            fileOutputStream.close();

        } catch (IOException e) {
            e.printStackTrace();
        }

    }
	

	
	public static byte[] compress(String string) throws IOException {
	    ByteArrayOutputStream os = new ByteArrayOutputStream(string.length());
	    GZIPOutputStream gos = new GZIPOutputStream(os);
	    gos.write(string.getBytes());
	    gos.close();
	    byte[] compressed = os.toByteArray();
	    os.close();
	    return compressed;
	}
	public static String decompress(byte[] compressed) throws IOException {
	    final int BUFFER_SIZE = 32;
	    ByteArrayInputStream is = new ByteArrayInputStream(compressed);
	    GZIPInputStream gis = new GZIPInputStream(is, BUFFER_SIZE);
	    StringBuilder string = new StringBuilder();
	    byte[] data = new byte[BUFFER_SIZE];
	    int bytesRead;
	    while ((bytesRead = gis.read(data)) != -1) {
	        string.append(new String(data, 0, bytesRead));
	    }
	    gis.close();
	    is.close();
	    return string.toString();
	}
	
	
}